include windows.inc
include masm32.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include ole32.inc
include oleaut32.inc
include \masm32\com\include\oaidl.inc
include \Masm32\COM\include\component.inc
include \RadASM\masm\inc\debug.inc

includelib masm32.lib
includelib kernel32.lib
includelib user32.lib
includelib Comctl32.lib
includelib shell32.lib
includelib ole32.lib
includelib oleaut32.lib
;includelib uuid.lib
includelib \RadASM\masm\lib\debug.lib

FindCbo		PROTO	:DWORD

szText MACRO Name, Text:VARARG
LOCAL lbl
  jmp lbl
	Name db Text,0
  lbl:
ENDM

m2m MACRO M1, M2
  push M2
  pop  M1
ENDM

return MACRO arg
  mov eax, arg
  ret
ENDM

WBM_RAINIT				equ WM_USER+9999;wParam=0, lParam=pointer to controls DIALOG struct
;Browser messages:
WBM_NAVIGATE			equ WM_USER+100	;wParam=0, lParam=pointer to null terminated string
WBM_GOBACK				equ WM_USER+101	;wParam=0, lParam=0
WBM_GOFORWARD			equ WM_USER+102	;wParam=0, lParam=0

;Browser styles:
WBS_STATUSWINDOW		equ 1
WBS_STATUSSIZEGRIP		equ 2
WBS_CAPTION				equ 4
WBS_COMBO				equ 8

STYLE					equ WS_CHILD or WS_VISIBLE or WBS_STATUSWINDOW or WBS_STATUSSIZEGRIP or WBS_CAPTION or WBS_COMBO
EXSTYLE					equ 0

MaxCap				equ 241

DIALOG struct
	hwnd			dd ?				;Set to TRUE
	hdmy			dd ?				;Transparent dummy window
	oldproc			dd ?				;Set to NULL
	hpar			dd ?				;Set to NULL
	hcld			dd ?				;Set to NULL
	style			dd ?				;Set to desired style
	exstyle			dd ?				;Set to desired ex style
	x				dd ?				;X position in pixels
	y				dd ?				;Y position in pixels
	ccx				dd ?				;Width in pixels
	ccy				dd ?				;Height in pixels
	caption			db MaxCap dup(?)	;Caption max 240+1 char
	ntype			dd ?				;Follows ToolBox buttons Dialog=0, Edit=1, Static=2, GroupBox=3
	ntypeid			dd ?				;Set to NULL
	tab				dd ?				;Tab index, Dialog=0, First index=0
	id				dd ?				;Dialog / Controls ID
	idname			db 32 dup(?)		;ID Name, max 31 chars
	undo			dd ?				;Set to NULL
	himg			dd ?				;Set to NULL
DIALOG ends

;Used by RadASM 1.2.0.5
CCDEF struct
	ID					dd ?		;Controls uniqe ID
	lptooltip			dd ?		;Pointer to tooltip text
	hbmp				dd ?		;Handle of bitmap
	lpcaption			dd ?		;Pointer to default caption text
	lpname				dd ?		;Pointer to default id-name text
	lpclass				dd ?		;Pointer to class text
	style				dd ?		;Default style
	exstyle				dd ?		;Default ex-style
	flist1				dd ?		;Property listbox 1
	flist2				dd ?		;Property listbox 2
	disable				dd ?		;Disable controls child windows. 0=No, 1=Use method 1, 2=Use method 2, 3=Use method 3
CCDEF ends

;Used by RadASM 2.1.0.4
CCDEFEX struct
	ID					dd ?		;Controls uniqe ID
	lptooltip			dd ?		;Pointer to tooltip text
	hbmp				dd ?		;Handle of bitmap
	lpcaption			dd ?		;Pointer to default caption text
	lpname				dd ?		;Pointer to default id-name text
	lpclass				dd ?		;Pointer to class text
	style				dd ?		;Default style
	exstyle				dd ?		;Default ex-style
	flist1				dd ?		;Property listbox 1
	flist2				dd ?		;Property listbox 2
	flist3				dd ?		;Property listbox 3
	flist4				dd ?		;Property listbox 4
	lpproperty			dd ?		;Pointer to properties text to add
	lpmethod			dd ?		;Pointer to property methods
CCDEFEX ends

IDB_WBBUTTON			equ 100

WBDATA struct
	hWBParentWnd		dd ?
	hWBStatusWnd		dd ?
	hWBCaptionWnd		dd ?
	hWBComboWnd			dd ?
	pObj				dd ?
WBDATA ends

PROP_STYLETRUEFALSE		equ 1
PROP_EXSTYLETRUEFALSE	equ 2
PROP_STYLEMULTI			equ 3

.data

szClassNameWB			db 'WEB_BROWSER',0
szClassStatus			db 'msctls_statusbar32',0
szClassStatic			db 'STATIC',0
szClassCombo			db 'COMBOBOX',0
szToolTip				db 'WebBrowser',0
szCap					db 'Address:',0
szName					db 'IDC_WBR',0

szProperty				db 'StatusBar,AdrCaption,AdrCombo',0
PropertyStatusBar		db 'None,Normal,SizeGrip',0
						dd -1 xor (WBS_STATUSWINDOW or WBS_STATUSSIZEGRIP),0
						dd -1,0
						dd -1 xor (WBS_STATUSWINDOW or WBS_STATUSSIZEGRIP),WBS_STATUSWINDOW
						dd -1,0
						dd -1 xor (WBS_STATUSWINDOW or WBS_STATUSSIZEGRIP),WBS_STATUSWINDOW or WBS_STATUSSIZEGRIP
						dd -1,0
PropertyCaption			dd -1 xor WBS_CAPTION,0
						dd -1 xor WBS_CAPTION,WBS_CAPTION
PropertyAdressCombo		dd -1 xor WBS_COMBO,0
						dd -1 xor WBS_COMBO,WBS_COMBO

Methods					dd PROP_STYLEMULTI,offset PropertyStatusBar
						dd PROP_STYLETRUEFALSE,offset PropertyCaption
						dd PROP_STYLETRUEFALSE,offset PropertyAdressCombo

;Create an initiated struct
ccdef					CCDEF <258,offset szToolTip,0,offset szCap,offset szName,offset szClassNameWB,STYLE,EXSTYLE,11111111000111000000000001000000b,00010000000000011000000000000000b,3>
ccdefex					CCDEFEX <258,offset szToolTip,0,offset szCap,offset szName,offset szClassNameWB,STYLE,EXSTYLE,11111111000111000000000001000000b,00010000000000011000000000000000b,00000000000000000000000000000000b,00000000000000000000000000000000b,offset szProperty,offset Methods>
szDisplayName			db 'Web-Browser',0

.data?

hInstance				dd ?
szNULL					db ?
hFont					dd ?
lpfnEditProc			dd ?
buffer					db 256 dup(?)
